"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.publishSite = void 0;
const unist_util_visit_1 = __importDefault(require("unist-util-visit"));
const types_1 = require("../types");
const utils_1 = require("../utils");
const utilsv5_1 = require("../utilsv5");
/**
 * Used when publishing
 * Rewrite index note
 */
function plugin(opts) {
    const proc = this;
    const { dest, config } = utilsv5_1.MDUtilsV5.getProcData(proc);
    function transformer(tree, _file) {
        if (dest !== types_1.DendronASTDest.HTML) {
            return;
        }
        (0, unist_util_visit_1.default)(tree, (node, _idx, _parent) => {
            if (node.type === types_1.DendronASTTypes.WIKI_LINK) {
                const cnode = node;
                const value = cnode.value;
                const href = utils_1.PublishUtils.getSiteUrl(config);
                if (value === opts.noteIndex.fname) {
                    node.data.hProperties = { href };
                }
            }
        });
        return tree;
    }
    return transformer;
}
exports.publishSite = plugin;
//# sourceMappingURL=publishSite.js.map